module.exports = function getLDJSONFactory() {
  return () => Array.from(
    document.querySelectorAll('script[type="application/ld+json"]'),
  )
    .map((item) => {
      try {
        const parsedJSON = JSON.parse(item.textContent);
        const ldJSON = Array.isArray(parsedJSON) ? parsedJSON : [parsedJSON];
        return ldJSON.map(obj => [obj['@type'], obj]);
      } catch (err) {
        return undefined;
      }
    })
    .filter(Boolean)
    .reduce((accum, values) => [...accum, ...values], [])
    .reduce((previous, [key, value]) => {
      Object.assign(previous, {
        [key]: previous[key] || [],
      });
      previous[key].push(value);
      return previous;
    }, {});
};
